
// Created by Greg
// https://coolbug.org/users/greg/


#include <stdlib.h>
#include <math.h>
#include <helianthus.h>


int seed;
double treeTime;
double cameraX, cameraY, cameraZoom = 1;
double mx, my, zmx, zmy;
double hue;


void tree(double t, double hue, int level) {
  saveState();
  stroke(colorByHSVA(hue, 1, 1, 0.5));

  rotate( (randomFloat()*2 - 1)*10 );

  rotate( sin(t*(randomFloat() + 1) + randomFloat()*2*PI)*randomFloat()*10 );


  double l = randomFloat() + 1;
  line(0, 0, 0, l);

  int count = randomNumber(2, 3);
  if (level <= 0) count = 0;
  if (count > 0) {
    translate(0, l);
    zoom(0.8);

    double da = count > 1 ? 1.2/(count-1)*30 : 0;
    rotate( -(count-1)/2.0*da );
    for(int i = 0; i < count; ++i) {
      tree(t, hue, level - 1);
      rotate(da);
    }
  }

  restoreState();
}

void init() {
  seed = randomNumber(0, 1000000);
  hue = colorGetHue(colorByName("#ffae00"));
}

void draw() {
  double w = worldGetWidth();
  double h = worldGetHeight();
  treeTime += worldGetFrameTime();

  if (keyWentDown("space")) seed = randomNumber(0, 1000000);

  srand(seed);

  saveState();
  translate(w/2, h*0.9);
  zoom(50);
  scale(1, -1);
  strokeWidth(0.2);

  double nmx = transformedMouseX();
  double nmy = transformedMouseY();
  if (mouseWentDown("right")) {
    zmx = nmx;
    zmy = nmy;
  }

  if (mouseDown("left")) {
    cameraX += nmx - mx;
    cameraY += nmy - my;
  }
  if (mouseDown("right")) {
    double k = pow(1.5, nmy - my);
    cameraZoom *= k;
    cameraX = k*(cameraX - zmx) + zmx;
    cameraY = k*(cameraY - zmy) + zmy;
  }
  mx = nmx;
  my = nmy;

  translate(cameraX, cameraY);
  zoom(cameraZoom);

  tree(treeTime, hue, 8);
  hue += worldGetFrameTime()*30;

  restoreState();
}


int main() {
  worldSetVariableFrameRate();
  worldSetResizable(TRUE);
  worldSetInit(&init);
  worldSetDraw(&draw);
  worldRun();
}
